package com.stats.excel.statsexcel.controller;

import com.alibaba.excel.EasyExcel;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.stats.excel.statsexcel.dbo.UserDBO;
import com.stats.excel.statsexcel.mapper.UserMapper;
import com.stats.excel.statsexcel.service.ExcelService;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.stage.FileChooser;
import javafx.stage.Stage;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;

import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;
import jakarta.annotation.Resource;
/**
 * 主页面操作
 */
@Controller
@Slf4j
public class ExcelController implements Initializable {
    @FXML
    private Button loginButton;
    @Resource
    private ExcelService excelService;
    @Resource
    private UserMapper userMapper;

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        FileChooser fileChooser = new FileChooser();//创建一个文件选择器对象
        Stage stage = new Stage();
        stage.setTitle("请选择要过滤的表格文件");
        loginButton.setOnAction(//打开多文件按钮事件处理机制
                (final ActionEvent e) -> {
                    List<UserDBO> resultUser = new ArrayList<>();
                    excelService.configureFileChooser(fileChooser);
                    List<File> list = fileChooser.showOpenMultipleDialog(stage);
                    if (list != null) {
                        //解析excel并保保存到数据库
                        list.stream().forEach((file) -> {
                            excelService.readExcels(resultUser, file);
                        });
                        // 测试下数据库
                        excelService.saveBatch(resultUser);
                        List<UserDBO> userDBOS = userMapper.selectList(new LambdaQueryWrapper<UserDBO>().last("limit 100"));
                        if (userDBOS.size() > 0) {
                            //读取数据库表数据并生成新的excel
                            EasyExcel.write(new File(System.getProperty("user.home") + "/Desktop/newExcel.xlsx"), UserDBO.class)
                                    .sheet()
                                    .doWrite(userDBOS);
                        }

                    }
                });
    }
//                                .registerWriteHandler(new LongestMatchColumnWidthStyleStrategy())
//                                .registerWriteHandler(new HorizontalCellStyleStrategy())
}